float playerX;
float playerY;
float playerSize = 20;
int enemyCount = 100;
float[] enemyXList = new float[enemyCount];
float[] enemyYList = new float[enemyCount];
boolean[] enemyActiveList = new boolean[enemyCount];
float[] enemySpeedList = new float[enemyCount];
float[] enemySizeList = new float[enemyCount];
color[] enemyColorList = new color[enemyCount];
void setup(){
  size(600, 400);
/*
  for(int i = 0; i < enemyCount; i++){
    enemyXList[i] = 0;
    enemyYList[i] = random(0, height);
    enemyActiveList[i] = false;
    enemySpeedList[i] = random(1, 3);
    enemySizeList[i] = random(10, 30);
    enemyColorList[i] = color(random(256), random(256), random(256));
  }
*/
}
int count = 0;
int gameStatus = 0;
void draw(){
  background(0);
  if(gameStatus == 0){
    fill(255);
    textAlign(CENTER);
    text("GAME START", width / 2, height / 2);
    return;
  }
  playerX = mouseX;
  playerY = mouseY;
  for(int i = 0; i < enemyCount; i++){
    if(enemyActiveList[i] == true){
      enemyXList[i] += enemySpeedList[i];
      if(isHit(playerX, playerY, playerSize,
          enemyXList[i], enemyYList[i], enemySizeList[i])){
        if(playerSize > enemySizeList[i]){
          playerSize += enemySizeList[i] * 0.1;
          enemyActiveList[i] = false;
        } else{
          gameStatus = 2;
        }
      }
      noStroke();
      fill(enemyColorList[i]);
      ellipse(enemyXList[i], enemyYList[i],
          enemySizeList[i], enemySizeList[i]);
    }
  }
  if(gameStatus == 1){
    noStroke();
    fill(255);
    ellipse(playerX, playerY, playerSize, playerSize);
  }
  if(gameStatus == 2){
    fill(255);
    textAlign(CENTER);
    text("GAME OVER", width / 2, height / 2);
  }
  count += 1;
  if(count % 30 == 0){
    createEnemy();
  }
}
void mousePressed(){
  if(gameStatus == 0){
    gameStatus = 1;
  }
  if(gameStatus == 2){
    gameStatus = 0;
    // 変数を初期化する関数resetを呼び出す
    reset();
  }
}
// 変数を初期化する関数resetを定義
void reset(){
  playerX = 0;
  playerY = 0;
  playerSize = 20;
  enemyCount = 100;
  enemyXList = new float[enemyCount];
  enemyYList = new float[enemyCount];
  enemyActiveList = new boolean[enemyCount];
  enemySpeedList = new float[enemyCount];
  enemySizeList = new float[enemyCount];
  enemyColorList = new color[enemyCount];
}

boolean isHit(float px, float py, float ps,
              float ex, float ey, float es){
  float distance = dist(px, py, ex, ey);
  if(distance < ps / 2 + es / 2){
    return true;
  }
  return false;
}
void createEnemy(){
  float x = 0;
  float y = random(0, height);
  float speed = random(-3, 4);
  if(speed < 0){
    x = width;
  }
  float size = random(playerSize * 0.5, playerSize * 2);
  color col = color(random(256), random(256), random(256));
  for(int i = 0; i < enemyCount; i++){
    if(enemyActiveList[i] == false){
      enemyXList[i] = x;
      enemyYList[i] = y;
      enemySpeedList[i] = speed;
      enemySizeList[i] = size;
      enemyColorList[i] = col;
      enemyActiveList[i] = true;
      break;
    }
  }
}