// float x = 50;
// float y = 200;
// float velocity = 5;
// float ex = 500;
// float ey = 200;
class Ship{
  public float x;
  public float y;
  public float velocity;
}
class Bullet{
  public float x;
  public float y;
  public float velocity;
}
Ship player;
Ship enemy;
Bullet bullet;
PImage[] playerImages;
PImage[] enemyImages;
int count = 0;
void setup(){
  size(600, 400);
  player = new Ship();
  player.x = 50; 
  player.y = 200; 
  enemy = new Ship();
  enemy.x = 500;
  enemy.y = 200;
  playerImages = new PImage[]{
    loadImage("player01.png"), loadImage("player02.png")
  };
  enemyImages = new PImage[]{
    loadImage("enemy01.png"), loadImage("enemy02.png")
  };
} 
void draw(){
  background(0);
  count += 1;
  player.y += player.velocity;
  image(playerImages[count / 10 % 2], player.x, player.y, 50, 50);
  image(enemyImages[count / 10 % 2], enemy.x, enemy.y, 50, 50);
  if(bullet != null){
    bullet.x += bullet.velocity;
    fill(255);
    ellipse(bullet.x, bullet.y, 10, 10);
  }
}
void keyPressed(){
  if(keyCode == UP){
    player.velocity = -5;
  }
  if(keyCode == DOWN){
    player.velocity = 5;
  }
  if(key == ' '){
    bullet = new Bullet();
    bullet.x = player.x;
    bullet.y = player.y;
    bullet.velocity = 5;
  }
}