class Player{
  public float x;
  public float y;
  public float width;
  public float height;
  public float velocityX;
  public float velocityY;
}
PImage playerImage;
Player player;
class Input{
  public boolean space;
  public boolean left;
  public boolean right;
}
Input input;
void setup(){
  size(600, 400);
  playerImage = loadImage("drone.png");
  player = new Player();
  player.width = 50;
  player.height = 30;
  player.x = 300 - 25;
  player.y = 200 - 15;
  input = new Input();
} 
void draw(){
  background(255);
  if(input.space){
    player.velocityY -=0.2;
  }
  if(input.left){
    player.velocityX -= 0.1;
  }
  if(input.right){
    player.velocityX += 0.1;
  }
  player.velocityY += 0.1;
  player.velocityX *= 0.98;
  player.y += player.velocityY;
  player.x += player.velocityX;
  image(playerImage, player.x, player.y, player.width, player.height);
}
void keyPressed(){
  if(key == ' '){
    input.space = true;
  }
  if(keyCode == RIGHT){
    input.right = true;
  }
  if(keyCode == LEFT){
    input.left = true;
  }
}
void keyReleased(){
  if(key == ' '){
    input.space = false;
  }
  if(keyCode == RIGHT){
    input.right = false;
  }
  if(keyCode == LEFT){
    input.left = false;
  }
}
